#include "other/function.other"

float rand(vec3 p){
	return fract(cos(dot(p,vec3(7667.,156.,265.6))) * 7365.552);
}

highp float hash( highp float n )
{
return fract(sin(n)*43758.5453);
}

highp float noise( in highp vec2 x )
{
highp vec2 p = floor(x);
highp vec2 f = fract(x);
f = f*f*(3.-2.*f);
highp float n = p.x + p.y*57.;
highp float res = mix(mix( hash(n+  0.), hash(n+  1.),f.x), mix( hash(n+ 57.), hash(n+ 58.),f.x),f.y);
return res;
}
//BSBE NOISE

#define amount 1.0

highp float noisev(
	highp vec2 x){
highp float n = 0.0;
for(int i = 0; i<int(amount); i++){
n = max(n, abs(
		sin(x.x+cos(
		(x.y+x.x)/
		(amount*2.0)))*
		cos(x.y-sin(
		(x.x-x.y)/
		(amount*2.0))))),

x *= matrot(1.0),

x += vec2(sin(TIME*0.1),
	cos(TIME*0.03))/(
	amount/2.0),

x += float(i)/amount;
	}
return 1.0-(n);
	}

float dither(highp vec2 p){
p = floor(p);
highp float pas = dot(p, vec2(0.1, p.y * 0.25));
return hash(pas)*0.01;}

highp float fbm(highp vec2 pos, float d){
float a = 0.65, b = 0.0;
pos *= 0.5;
for(int loop = 0;loop<5;loop++){
	b += noisev(pos)*1.0*d/a;
a *= 2.2;
pos *= 2.3;
pos -= TIME*0.03;
}
return 1.0-pow(0.0, max(1.0-b,0.0));}

highp vec4 c(highp vec2 x, float density){
	vec4 a = vec4(0.0), bb = vec4(1.0);
	float c = (density);

	x *= 2.5;

	float vol = 0.0;

	for(float loop = 0.0; loop < vol; loop++){
	
	x += clamp(dither (x*600.0),0.0,1.0);	

		if(loop > (vol-4.0)){
		bb *= vec4(0.7992);
		}

		x /= 1.02; c /= 1.031;

		a = mix(a, bb, clamp(fbm((x+TIME*0.06),c), 0.0, 1.0));
		}

	return clamp(a, 0.0, 1.0);
}

highp float getWave(vec2 uv){
 float speed = 0.9;
	highp float waveShape =
	noise((vec2(uv.y+uv.y+uv.y+TIME*1.2*speed, uv.y+uv.x+TIME*1.9*speed)*0.7)) +
	noise((vec2(uv.x+uv.y+uv.y-TIME*1.2*speed, uv.y+uv.y-TIME*1.9*speed)*0.7));
	return waveShape*0.4;

	}